# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import io
import re  # noqa: F401
import warnings

from getopenpay.api_client import ApiClient
from getopenpay.api_response import ApiResponse
from getopenpay.exceptions import ApiTypeError, ApiValueError  # noqa: F401
from getopenpay.models.billing_meter_event_external import BillingMeterEventExternal
from getopenpay.models.create_billing_meter_event_request import CreateBillingMeterEventRequest
from getopenpay.models.list_billing_meter_event_summaries_request import (
  ListBillingMeterEventSummariesRequest
)
from pydantic import ValidationError, validate_arguments


class BillingMeterEventsApi:
  """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

  def __init__(self, api_client=None) -> None:
    if api_client is None:
      api_client = ApiClient.get_default()
    self.api_client = api_client

  @validate_arguments
  def create_billing_meter_event(
    self, create_billing_meter_event_request: CreateBillingMeterEventRequest, **kwargs
  ) -> BillingMeterEventExternal:  # noqa: E501
    """Create Billing Meter Event  # noqa: E501

        A billing meter event represents a customer’s usage of a product. Meter events are used to bill a customer based on their usage. Meter events are associated with billing meters, which define the shape of the event’s payload and how those events are aggregated for billing. Every event is identified by an unique identifier, same identifier can not be used again.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_billing_meter_event(create_billing_meter_event_request, async_req=True)
        >>> result = thread.get()

        :param create_billing_meter_event_request: (required)
        :type create_billing_meter_event_request: CreateBillingMeterEventRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: BillingMeterEventExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the create_billing_meter_event_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.create_billing_meter_event_with_http_info(
      create_billing_meter_event_request, **kwargs
    )  # noqa: E501

  @validate_arguments
  def create_billing_meter_event_with_http_info(
    self, create_billing_meter_event_request: CreateBillingMeterEventRequest, **kwargs
  ) -> ApiResponse:  # noqa: E501
    """Create Billing Meter Event  # noqa: E501

        A billing meter event represents a customer’s usage of a product. Meter events are used to bill a customer based on their usage. Meter events are associated with billing meters, which define the shape of the event’s payload and how those events are aggregated for billing. Every event is identified by an unique identifier, same identifier can not be used again.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_billing_meter_event_with_http_info(create_billing_meter_event_request, async_req=True)
        >>> result = thread.get()

        :param create_billing_meter_event_request: (required)
        :type create_billing_meter_event_request: CreateBillingMeterEventRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(BillingMeterEventExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['create_billing_meter_event_request']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method create_billing_meter_event' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    if _params['create_billing_meter_event_request'] is not None:
      _body_params = _params['create_billing_meter_event_request']

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # set the HTTP header `Content-Type`
    _content_types_list = _params.get(
      '_content_type', self.api_client.select_header_content_type(['application/json'])
    )
    if _content_types_list:
      _header_params['Content-Type'] = _content_types_list

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'BillingMeterEventExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/billing/meter-events/',
      'POST',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def list_billing_meter_event_summaries(
    self, list_billing_meter_event_summaries_request: ListBillingMeterEventSummariesRequest,
    **kwargs
  ) -> None:  # noqa: E501
    """List Billing Meter Event Summaries  # noqa: E501

        A billing meter event summary represents an aggregated view of a customer’s billing meter events within a specified timeframe. It indicates how much usage was accrued by a customer for that period.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_billing_meter_event_summaries(list_billing_meter_event_summaries_request, async_req=True)
        >>> result = thread.get()

        :param list_billing_meter_event_summaries_request: (required)
        :type list_billing_meter_event_summaries_request: ListBillingMeterEventSummariesRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the list_billing_meter_event_summaries_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.list_billing_meter_event_summaries_with_http_info(
      list_billing_meter_event_summaries_request, **kwargs
    )  # noqa: E501

  @validate_arguments
  def list_billing_meter_event_summaries_with_http_info(
    self, list_billing_meter_event_summaries_request: ListBillingMeterEventSummariesRequest,
    **kwargs
  ) -> ApiResponse:  # noqa: E501
    """List Billing Meter Event Summaries  # noqa: E501

        A billing meter event summary represents an aggregated view of a customer’s billing meter events within a specified timeframe. It indicates how much usage was accrued by a customer for that period.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_billing_meter_event_summaries_with_http_info(list_billing_meter_event_summaries_request, async_req=True)
        >>> result = thread.get()

        :param list_billing_meter_event_summaries_request: (required)
        :type list_billing_meter_event_summaries_request: ListBillingMeterEventSummariesRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """

    _params = locals()

    _all_params = ['list_billing_meter_event_summaries_request']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method list_billing_meter_event_summaries' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    if _params['list_billing_meter_event_summaries_request'] is not None:
      _body_params = _params['list_billing_meter_event_summaries_request']

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # set the HTTP header `Content-Type`
    _content_types_list = _params.get(
      '_content_type', self.api_client.select_header_content_type(['application/json'])
    )
    if _content_types_list:
      _header_params['Content-Type'] = _content_types_list

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {}

    return self.api_client.call_api(
      '/billing/meter-events/list',
      'POST',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )
