# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import io
import re  # noqa: F401
import warnings

from getopenpay.api_client import ApiClient
from getopenpay.api_response import ApiResponse
from getopenpay.exceptions import ApiTypeError, ApiValueError  # noqa: F401
from getopenpay.models.billing_meter_external import BillingMeterExternal
from getopenpay.models.billing_meter_query_params import BillingMeterQueryParams
from getopenpay.models.create_billing_meter_request import CreateBillingMeterRequest
from getopenpay.models.list_response_billing_meter_external import ListResponseBillingMeterExternal
from pydantic import StrictStr, ValidationError, validate_arguments


class BillingMetersApi:
  """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

  def __init__(self, api_client=None) -> None:
    if api_client is None:
      api_client = ApiClient.get_default()
    self.api_client = api_client

  @validate_arguments
  def create_billing_meter(
    self, create_billing_meter_request: CreateBillingMeterRequest, **kwargs
  ) -> BillingMeterExternal:  # noqa: E501
    """Create Billing Meter  # noqa: E501

        Creates a billing meter. A billing meter is a resource that allows you to track usage of a particular event.  For example, you might create a billing meter to track the number of API calls made by  a particular user. You can then attach the billing meter to a price and attach the price to a subscription   to charge the user for the number of API calls they make.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_billing_meter(create_billing_meter_request, async_req=True)
        >>> result = thread.get()

        :param create_billing_meter_request: (required)
        :type create_billing_meter_request: CreateBillingMeterRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: BillingMeterExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the create_billing_meter_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.create_billing_meter_with_http_info(
      create_billing_meter_request, **kwargs
    )  # noqa: E501

  @validate_arguments
  def create_billing_meter_with_http_info(
    self, create_billing_meter_request: CreateBillingMeterRequest, **kwargs
  ) -> ApiResponse:  # noqa: E501
    """Create Billing Meter  # noqa: E501

        Creates a billing meter. A billing meter is a resource that allows you to track usage of a particular event.  For example, you might create a billing meter to track the number of API calls made by  a particular user. You can then attach the billing meter to a price and attach the price to a subscription   to charge the user for the number of API calls they make.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_billing_meter_with_http_info(create_billing_meter_request, async_req=True)
        >>> result = thread.get()

        :param create_billing_meter_request: (required)
        :type create_billing_meter_request: CreateBillingMeterRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(BillingMeterExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['create_billing_meter_request']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method create_billing_meter' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    if _params['create_billing_meter_request'] is not None:
      _body_params = _params['create_billing_meter_request']

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # set the HTTP header `Content-Type`
    _content_types_list = _params.get(
      '_content_type', self.api_client.select_header_content_type(['application/json'])
    )
    if _content_types_list:
      _header_params['Content-Type'] = _content_types_list

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'BillingMeterExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/billing/meters/',
      'POST',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def deactivate_billing_meter(
    self, meter_id: StrictStr, **kwargs
  ) -> BillingMeterExternal:  # noqa: E501
    """Deactivate Billing Meter  # noqa: E501

        Deactivates a billing meter.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.deactivate_billing_meter(meter_id, async_req=True)
        >>> result = thread.get()

        :param meter_id: (required)
        :type meter_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: BillingMeterExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the deactivate_billing_meter_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.deactivate_billing_meter_with_http_info(meter_id, **kwargs)  # noqa: E501

  @validate_arguments
  def deactivate_billing_meter_with_http_info(
    self, meter_id: StrictStr, **kwargs
  ) -> ApiResponse:  # noqa: E501
    """Deactivate Billing Meter  # noqa: E501

        Deactivates a billing meter.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.deactivate_billing_meter_with_http_info(meter_id, async_req=True)
        >>> result = thread.get()

        :param meter_id: (required)
        :type meter_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(BillingMeterExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['meter_id']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method deactivate_billing_meter' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}
    if _params['meter_id'] is not None:
      _path_params['meter_id'] = _params['meter_id']

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'BillingMeterExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/billing/meters/{meter_id}/deactivate',
      'POST',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def get_billing_meter(self, meter_id: StrictStr, **kwargs) -> BillingMeterExternal:  # noqa: E501
    """Get Billing Meter  # noqa: E501

        Retrieves a billing meter given an ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_billing_meter(meter_id, async_req=True)
        >>> result = thread.get()

        :param meter_id: (required)
        :type meter_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: BillingMeterExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the get_billing_meter_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.get_billing_meter_with_http_info(meter_id, **kwargs)  # noqa: E501

  @validate_arguments
  def get_billing_meter_with_http_info(
    self, meter_id: StrictStr, **kwargs
  ) -> ApiResponse:  # noqa: E501
    """Get Billing Meter  # noqa: E501

        Retrieves a billing meter given an ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_billing_meter_with_http_info(meter_id, async_req=True)
        >>> result = thread.get()

        :param meter_id: (required)
        :type meter_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(BillingMeterExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['meter_id']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method get_billing_meter' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}
    if _params['meter_id'] is not None:
      _path_params['meter_id'] = _params['meter_id']

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'BillingMeterExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/billing/meters/{meter_id}',
      'GET',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def list_billing_meters(
    self, billing_meter_query_params: BillingMeterQueryParams, **kwargs
  ) -> ListResponseBillingMeterExternal:  # noqa: E501
    """List Billing Meters  # noqa: E501

        Retrieve a list of billing meters.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_billing_meters(billing_meter_query_params, async_req=True)
        >>> result = thread.get()

        :param billing_meter_query_params: (required)
        :type billing_meter_query_params: BillingMeterQueryParams
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ListResponseBillingMeterExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the list_billing_meters_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.list_billing_meters_with_http_info(
      billing_meter_query_params, **kwargs
    )  # noqa: E501

  @validate_arguments
  def list_billing_meters_with_http_info(
    self, billing_meter_query_params: BillingMeterQueryParams, **kwargs
  ) -> ApiResponse:  # noqa: E501
    """List Billing Meters  # noqa: E501

        Retrieve a list of billing meters.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_billing_meters_with_http_info(billing_meter_query_params, async_req=True)
        >>> result = thread.get()

        :param billing_meter_query_params: (required)
        :type billing_meter_query_params: BillingMeterQueryParams
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ListResponseBillingMeterExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['billing_meter_query_params']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method list_billing_meters' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    if _params['billing_meter_query_params'] is not None:
      _body_params = _params['billing_meter_query_params']

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # set the HTTP header `Content-Type`
    _content_types_list = _params.get(
      '_content_type', self.api_client.select_header_content_type(['application/json'])
    )
    if _content_types_list:
      _header_params['Content-Type'] = _content_types_list

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'ListResponseBillingMeterExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/billing/meters/list',
      'POST',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def reactivate_billing_meter(
    self, meter_id: StrictStr, **kwargs
  ) -> BillingMeterExternal:  # noqa: E501
    """Reactivate Billing Meter  # noqa: E501

        Reactivates a billing meter.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.reactivate_billing_meter(meter_id, async_req=True)
        >>> result = thread.get()

        :param meter_id: (required)
        :type meter_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: BillingMeterExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the reactivate_billing_meter_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.reactivate_billing_meter_with_http_info(meter_id, **kwargs)  # noqa: E501

  @validate_arguments
  def reactivate_billing_meter_with_http_info(
    self, meter_id: StrictStr, **kwargs
  ) -> ApiResponse:  # noqa: E501
    """Reactivate Billing Meter  # noqa: E501

        Reactivates a billing meter.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.reactivate_billing_meter_with_http_info(meter_id, async_req=True)
        >>> result = thread.get()

        :param meter_id: (required)
        :type meter_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(BillingMeterExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['meter_id']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method reactivate_billing_meter' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}
    if _params['meter_id'] is not None:
      _path_params['meter_id'] = _params['meter_id']

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'BillingMeterExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/billing/meters/{meter_id}/reactivate',
      'POST',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )
