# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import io
import re  # noqa: F401
import warnings

from getopenpay.api_client import ApiClient
from getopenpay.api_response import ApiResponse
from getopenpay.exceptions import ApiTypeError, ApiValueError  # noqa: F401
from getopenpay.models.coupon_external import CouponExternal
from getopenpay.models.coupon_query_params import CouponQueryParams
from getopenpay.models.create_coupon_request import CreateCouponRequest
from getopenpay.models.list_response_coupon_external import ListResponseCouponExternal
from getopenpay.models.update_coupon_request import UpdateCouponRequest
from pydantic import Field, StrictStr, ValidationError, validate_arguments
from typing_extensions import Annotated


class CouponsApi:
  """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

  def __init__(self, api_client=None) -> None:
    if api_client is None:
      api_client = ApiClient.get_default()
    self.api_client = api_client

  @validate_arguments
  def create_coupon(
    self, create_coupon_request: CreateCouponRequest, **kwargs
  ) -> CouponExternal:  # noqa: E501
    """Create Coupon  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_coupon(create_coupon_request, async_req=True)
        >>> result = thread.get()

        :param create_coupon_request: (required)
        :type create_coupon_request: CreateCouponRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: CouponExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the create_coupon_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.create_coupon_with_http_info(create_coupon_request, **kwargs)  # noqa: E501

  @validate_arguments
  def create_coupon_with_http_info(
    self, create_coupon_request: CreateCouponRequest, **kwargs
  ) -> ApiResponse:  # noqa: E501
    """Create Coupon  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_coupon_with_http_info(create_coupon_request, async_req=True)
        >>> result = thread.get()

        :param create_coupon_request: (required)
        :type create_coupon_request: CreateCouponRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(CouponExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['create_coupon_request']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method create_coupon' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    if _params['create_coupon_request'] is not None:
      _body_params = _params['create_coupon_request']

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # set the HTTP header `Content-Type`
    _content_types_list = _params.get(
      '_content_type', self.api_client.select_header_content_type(['application/json'])
    )
    if _content_types_list:
      _header_params['Content-Type'] = _content_types_list

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '201': 'CouponExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/coupons/',
      'POST',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def delete_coupon(
    self, coupon_id: Annotated[StrictStr,
                               Field(..., description='Unique identifier of the Coupon.')], **kwargs
  ) -> None:  # noqa: E501
    """Delete Coupon  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_coupon(coupon_id, async_req=True)
        >>> result = thread.get()

        :param coupon_id: Unique identifier of the Coupon. (required)
        :type coupon_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the delete_coupon_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.delete_coupon_with_http_info(coupon_id, **kwargs)  # noqa: E501

  @validate_arguments
  def delete_coupon_with_http_info(
    self, coupon_id: Annotated[StrictStr,
                               Field(..., description='Unique identifier of the Coupon.')], **kwargs
  ) -> ApiResponse:  # noqa: E501
    """Delete Coupon  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_coupon_with_http_info(coupon_id, async_req=True)
        >>> result = thread.get()

        :param coupon_id: Unique identifier of the Coupon. (required)
        :type coupon_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """

    _params = locals()

    _all_params = ['coupon_id']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method delete_coupon' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}
    if _params['coupon_id'] is not None:
      _path_params['coupon_id'] = _params['coupon_id']

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {}

    return self.api_client.call_api(
      '/coupons/{coupon_id}',
      'DELETE',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def get_coupon(
    self, coupon_id: Annotated[StrictStr,
                               Field(..., description='Unique identifier of the Coupon.')], **kwargs
  ) -> CouponExternal:  # noqa: E501
    """Get Coupon  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_coupon(coupon_id, async_req=True)
        >>> result = thread.get()

        :param coupon_id: Unique identifier of the Coupon. (required)
        :type coupon_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: CouponExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the get_coupon_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.get_coupon_with_http_info(coupon_id, **kwargs)  # noqa: E501

  @validate_arguments
  def get_coupon_with_http_info(
    self, coupon_id: Annotated[StrictStr,
                               Field(..., description='Unique identifier of the Coupon.')], **kwargs
  ) -> ApiResponse:  # noqa: E501
    """Get Coupon  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_coupon_with_http_info(coupon_id, async_req=True)
        >>> result = thread.get()

        :param coupon_id: Unique identifier of the Coupon. (required)
        :type coupon_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(CouponExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['coupon_id']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method get_coupon' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}
    if _params['coupon_id'] is not None:
      _path_params['coupon_id'] = _params['coupon_id']

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'CouponExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/coupons/{coupon_id}',
      'GET',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def list_coupons(
    self, coupon_query_params: CouponQueryParams, **kwargs
  ) -> ListResponseCouponExternal:  # noqa: E501
    """List Coupons  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_coupons(coupon_query_params, async_req=True)
        >>> result = thread.get()

        :param coupon_query_params: (required)
        :type coupon_query_params: CouponQueryParams
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ListResponseCouponExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the list_coupons_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.list_coupons_with_http_info(coupon_query_params, **kwargs)  # noqa: E501

  @validate_arguments
  def list_coupons_with_http_info(
    self, coupon_query_params: CouponQueryParams, **kwargs
  ) -> ApiResponse:  # noqa: E501
    """List Coupons  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_coupons_with_http_info(coupon_query_params, async_req=True)
        >>> result = thread.get()

        :param coupon_query_params: (required)
        :type coupon_query_params: CouponQueryParams
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ListResponseCouponExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['coupon_query_params']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method list_coupons' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    if _params['coupon_query_params'] is not None:
      _body_params = _params['coupon_query_params']

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # set the HTTP header `Content-Type`
    _content_types_list = _params.get(
      '_content_type', self.api_client.select_header_content_type(['application/json'])
    )
    if _content_types_list:
      _header_params['Content-Type'] = _content_types_list

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'ListResponseCouponExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/coupons/list',
      'POST',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def update_coupon(
    self, coupon_id: Annotated[StrictStr,
                               Field(..., description='Unique identifier of the Coupon.')],
    update_coupon_request: UpdateCouponRequest, **kwargs
  ) -> CouponExternal:  # noqa: E501
    """Update Coupon  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_coupon(coupon_id, update_coupon_request, async_req=True)
        >>> result = thread.get()

        :param coupon_id: Unique identifier of the Coupon. (required)
        :type coupon_id: str
        :param update_coupon_request: (required)
        :type update_coupon_request: UpdateCouponRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: CouponExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the update_coupon_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.update_coupon_with_http_info(
      coupon_id, update_coupon_request, **kwargs
    )  # noqa: E501

  @validate_arguments
  def update_coupon_with_http_info(
    self, coupon_id: Annotated[StrictStr,
                               Field(..., description='Unique identifier of the Coupon.')],
    update_coupon_request: UpdateCouponRequest, **kwargs
  ) -> ApiResponse:  # noqa: E501
    """Update Coupon  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_coupon_with_http_info(coupon_id, update_coupon_request, async_req=True)
        >>> result = thread.get()

        :param coupon_id: Unique identifier of the Coupon. (required)
        :type coupon_id: str
        :param update_coupon_request: (required)
        :type update_coupon_request: UpdateCouponRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(CouponExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['coupon_id', 'update_coupon_request']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method update_coupon' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}
    if _params['coupon_id'] is not None:
      _path_params['coupon_id'] = _params['coupon_id']

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    if _params['update_coupon_request'] is not None:
      _body_params = _params['update_coupon_request']

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # set the HTTP header `Content-Type`
    _content_types_list = _params.get(
      '_content_type', self.api_client.select_header_content_type(['application/json'])
    )
    if _content_types_list:
      _header_params['Content-Type'] = _content_types_list

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'CouponExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/coupons/{coupon_id}',
      'PUT',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )
