# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import io
import re  # noqa: F401
import warnings

from getopenpay.api_client import ApiClient
from getopenpay.api_response import ApiResponse
from getopenpay.exceptions import ApiTypeError, ApiValueError  # noqa: F401
from getopenpay.models.event_external import EventExternal
from getopenpay.models.event_search_params import EventSearchParams
from getopenpay.models.events_query_params import EventsQueryParams
from getopenpay.models.list_response_event_external import ListResponseEventExternal
from pydantic import StrictStr, ValidationError, validate_arguments


class EventsApi:
  """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

  def __init__(self, api_client=None) -> None:
    if api_client is None:
      api_client = ApiClient.get_default()
    self.api_client = api_client

  @validate_arguments
  def get_event(self, event_id: StrictStr, **kwargs) -> EventExternal:  # noqa: E501
    """Get Event  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_event(event_id, async_req=True)
        >>> result = thread.get()

        :param event_id: (required)
        :type event_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: EventExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the get_event_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.get_event_with_http_info(event_id, **kwargs)  # noqa: E501

  @validate_arguments
  def get_event_with_http_info(self, event_id: StrictStr, **kwargs) -> ApiResponse:  # noqa: E501
    """Get Event  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_event_with_http_info(event_id, async_req=True)
        >>> result = thread.get()

        :param event_id: (required)
        :type event_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(EventExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['event_id']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError("Got an unexpected keyword argument '%s'"
                           ' to method get_event' % _key)
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}
    if _params['event_id'] is not None:
      _path_params['event_id'] = _params['event_id']

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'EventExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/events/{event_id}',
      'GET',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def list_events(
    self, events_query_params: EventsQueryParams, **kwargs
  ) -> ListResponseEventExternal:  # noqa: E501
    """List Events  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_events(events_query_params, async_req=True)
        >>> result = thread.get()

        :param events_query_params: (required)
        :type events_query_params: EventsQueryParams
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ListResponseEventExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the list_events_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.list_events_with_http_info(events_query_params, **kwargs)  # noqa: E501

  @validate_arguments
  def list_events_with_http_info(
    self, events_query_params: EventsQueryParams, **kwargs
  ) -> ApiResponse:  # noqa: E501
    """List Events  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_events_with_http_info(events_query_params, async_req=True)
        >>> result = thread.get()

        :param events_query_params: (required)
        :type events_query_params: EventsQueryParams
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ListResponseEventExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['events_query_params']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method list_events' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    if _params['events_query_params'] is not None:
      _body_params = _params['events_query_params']

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # set the HTTP header `Content-Type`
    _content_types_list = _params.get(
      '_content_type', self.api_client.select_header_content_type(['application/json'])
    )
    if _content_types_list:
      _header_params['Content-Type'] = _content_types_list

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'ListResponseEventExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/events/list',
      'POST',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )

  @validate_arguments
  def search_events(
    self, event_search_params: EventSearchParams, **kwargs
  ) -> ListResponseEventExternal:  # noqa: E501
    """Search Events  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.search_events(event_search_params, async_req=True)
        >>> result = thread.get()

        :param event_search_params: (required)
        :type event_search_params: EventSearchParams
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: ListResponseEventExternal
        """
    kwargs['_return_http_data_only'] = True
    if '_preload_content' in kwargs:
      message = 'Error! Please call the search_events_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data'  # noqa: E501
      raise ValueError(message)
    return self.search_events_with_http_info(event_search_params, **kwargs)  # noqa: E501

  @validate_arguments
  def search_events_with_http_info(
    self, event_search_params: EventSearchParams, **kwargs
  ) -> ApiResponse:  # noqa: E501
    """Search Events  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.search_events_with_http_info(event_search_params, async_req=True)
        >>> result = thread.get()

        :param event_search_params: (required)
        :type event_search_params: EventSearchParams
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(ListResponseEventExternal, status_code(int), headers(HTTPHeaderDict))
        """

    _params = locals()

    _all_params = ['event_search_params']
    _all_params.extend(
      [
        'async_req', '_return_http_data_only', '_preload_content', '_request_timeout',
        '_request_auth', '_content_type', '_headers'
      ]
    )

    # validate the arguments
    for _key, _val in _params['kwargs'].items():
      if _key not in _all_params:
        raise ApiTypeError(
          "Got an unexpected keyword argument '%s'"
          ' to method search_events' % _key
        )
      _params[_key] = _val
    del _params['kwargs']

    _collection_formats = {}

    # process the path parameters
    _path_params = {}

    # process the query parameters
    _query_params = []
    # process the header parameters
    _header_params = dict(_params.get('_headers', {}))
    # process the form parameters
    _form_params = []
    _files = {}
    # process the body parameter
    _body_params = None
    if _params['event_search_params'] is not None:
      _body_params = _params['event_search_params']

    # set the HTTP header `Accept`
    _header_params['Accept'] = self.api_client.select_header_accept(
      ['application/json']
    )  # noqa: E501

    # set the HTTP header `Content-Type`
    _content_types_list = _params.get(
      '_content_type', self.api_client.select_header_content_type(['application/json'])
    )
    if _content_types_list:
      _header_params['Content-Type'] = _content_types_list

    # authentication setting
    _auth_settings = ['HTTPBearer']  # noqa: E501

    _response_types_map = {
      '200': 'ListResponseEventExternal',
      '422': 'HTTPValidationError',
    }

    return self.api_client.call_api(
      '/events/search',
      'POST',
      _path_params,
      _query_params,
      _header_params,
      body=_body_params,
      post_params=_form_params,
      files=_files,
      response_types_map=_response_types_map,
      auth_settings=_auth_settings,
      async_req=_params.get('async_req'),
      _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
      _preload_content=_params.get('_preload_content', True),
      _request_timeout=_params.get('_request_timeout'),
      collection_formats=_collection_formats,
      _request_auth=_params.get('_request_auth')
    )
