# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from getopenpay.models.currency_enum import CurrencyEnum
from pydantic import BaseModel, Field, StrictInt, StrictStr


class AuthorizePaymentMethodRequest(BaseModel):
  """
    AuthorizePaymentMethodRequest
    """
  payment_method_id: StrictStr = Field(..., description='Unique identifier of the payment method.')
  authorize_amount_atom: Optional[StrictInt] = Field(
    2000, description='Amount to authorize in atoms (smallest currency unit).'
  )
  currency: Optional[CurrencyEnum] = None
  __properties = ['payment_method_id', 'authorize_amount_atom', 'currency']

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> AuthorizePaymentMethodRequest:
    """Create an instance of AuthorizePaymentMethodRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> AuthorizePaymentMethodRequest:
    """Create an instance of AuthorizePaymentMethodRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return AuthorizePaymentMethodRequest.parse_obj(obj)

    _obj = AuthorizePaymentMethodRequest.parse_obj(
      {
        'payment_method_id': obj.get('payment_method_id'),
        'authorize_amount_atom':
          obj.get('authorize_amount_atom')
          if obj.get('authorize_amount_atom') is not None else 2000,
        'currency': obj.get('currency')
      }
    )
    return _obj
