# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, Dict, Optional

from getopenpay.models.billing_meter_event_status import BillingMeterEventStatus
from getopenpay.models.object_name import ObjectName
from pydantic import BaseModel, Field, StrictBool, StrictStr


class BillingMeterEventExternal(BaseModel):
  """
    BillingMeterEventExternal
    """
  event_name: StrictStr = Field(
    ...,
    description='The name of the meter event. Corresponds with the event_name field on a meter.'
  )
  payload: Dict[str, Any] = Field(
    ...,
    description=
    'The payload of the event. This must contain the fields corresponding to a meter’s event_payload_customer_mapping_key (default is customer_id) and event_payload_value_key (default is value). '
  )
  identifier: Optional[StrictStr] = Field(
    None,
    description=
    'A unique identifier for the event. If not provided, one will be generated. We recommend using a globally unique identifier for this.'
  )
  event_datetime: Optional[datetime] = Field(None, description='The time of the event.')
  id: StrictStr = Field(..., description='Unique identifier of meter event.')
  object: Optional[ObjectName] = None
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  is_deleted: Optional[StrictBool] = Field(
    False, description='If true, indicates that this object has been deleted'
  )
  account_id: StrictStr = Field(..., description='Unique identifier for the account.')
  status: BillingMeterEventStatus = Field(...)
  __properties = [
    'event_name', 'payload', 'identifier', 'event_datetime', 'id', 'object', 'created_at',
    'updated_at', 'is_deleted', 'account_id', 'status'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> BillingMeterEventExternal:
    """Create an instance of BillingMeterEventExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> BillingMeterEventExternal:
    """Create an instance of BillingMeterEventExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return BillingMeterEventExternal.parse_obj(obj)

    _obj = BillingMeterEventExternal.parse_obj(
      {
        'event_name': obj.get('event_name'),
        'payload': obj.get('payload'),
        'identifier': obj.get('identifier'),
        'event_datetime': obj.get('event_datetime'),
        'id': obj.get('id'),
        'object': obj.get('object'),
        'created_at': obj.get('created_at'),
        'updated_at': obj.get('updated_at'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'account_id': obj.get('account_id'),
        'status': obj.get('status')
      }
    )
    return _obj
