# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Optional

from getopenpay.models.billing_meter_aggregation_formula import BillingMeterAggregationFormula
from getopenpay.models.object_name import ObjectName
from pydantic import BaseModel, Field, StrictBool, StrictStr, constr, validator


class BillingMeterExternal(BaseModel):
  """
    BillingMeterExternal
    """
  display_name: StrictStr = Field(..., description='The meter’s name.')
  event_name: constr(strict=True) = Field(
    ...,
    description=
    'The name of the meter event to record usage for. Corresponds with the event_name field on meter events.'
  )
  aggregation_formula: Optional[BillingMeterAggregationFormula] = None
  event_payload_customer_mapping_key: Optional[StrictStr] = Field(
    'customer_id',
    description='The key in the usage event payload to use for mapping the event to a customer.'
  )
  event_payload_value_key: Optional[StrictStr] = Field(
    'value',
    description=
    'The key in the usage event payload to use as the value for this meter. For example, if the event payload contains usage on a bytes_used field, then set the event_payload_value_key to “bytes_used”.'
  )
  id: StrictStr = Field(..., description='Unique Identifier of the Billing Meter.')
  object: Optional[ObjectName] = None
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  is_deleted: Optional[StrictBool] = Field(
    False, description='If true, indicates that this object has been deleted'
  )
  account_id: StrictStr = Field(..., description='Unique identifier for the account.')
  is_active: StrictBool = Field(..., description='The meter’s status.')
  __properties = [
    'display_name', 'event_name', 'aggregation_formula', 'event_payload_customer_mapping_key',
    'event_payload_value_key', 'id', 'object', 'created_at', 'updated_at', 'is_deleted',
    'account_id', 'is_active'
  ]

  @validator('event_name')
  def event_name_validate_regular_expression(cls, value):
    """Validates the regular expression"""
    if not re.match(r'^[A-Za-z0-9_-]+$', value):
      raise ValueError(r'must validate the regular expression /^[A-Za-z0-9_-]+$/')
    return value

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> BillingMeterExternal:
    """Create an instance of BillingMeterExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> BillingMeterExternal:
    """Create an instance of BillingMeterExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return BillingMeterExternal.parse_obj(obj)

    _obj = BillingMeterExternal.parse_obj(
      {
        'display_name': obj.get('display_name'),
        'event_name': obj.get('event_name'),
        'aggregation_formula': obj.get('aggregation_formula'),
        'event_payload_customer_mapping_key':
          obj.get('event_payload_customer_mapping_key')
          if obj.get('event_payload_customer_mapping_key') is not None else 'customer_id',
        'event_payload_value_key':
          obj.get('event_payload_value_key')
          if obj.get('event_payload_value_key') is not None else 'value',
        'id': obj.get('id'),
        'object': obj.get('object'),
        'created_at': obj.get('created_at'),
        'updated_at': obj.get('updated_at'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'account_id': obj.get('account_id'),
        'is_active': obj.get('is_active')
      }
    )
    return _obj
