# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from getopenpay.models.credit_note_line_type import CreditNoteLineType
from getopenpay.models.currency_enum import CurrencyEnum
from pydantic import BaseModel, Field, StrictInt, StrictStr


class CreateCreditNoteLine(BaseModel):
  """
    CreateCreditNoteLine
    """
  amount_atom: StrictInt = Field(
    ...,
    description='The integer amount representing the gross amount being credited for this line item.'
  )
  currency: CurrencyEnum = Field(...)
  type: CreditNoteLineType = Field(...)
  quantity: Optional[StrictInt] = 1
  invoice_item_id: Optional[StrictStr] = None
  unit_amount_atom: Optional[StrictInt] = None
  __properties = [
    'amount_atom', 'currency', 'type', 'quantity', 'invoice_item_id', 'unit_amount_atom'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> CreateCreditNoteLine:
    """Create an instance of CreateCreditNoteLine from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # set to None if invoice_item_id (nullable) is None
    # and __fields_set__ contains the field
    if self.invoice_item_id is None and 'invoice_item_id' in self.__fields_set__:
      _dict['invoice_item_id'] = None

    # set to None if unit_amount_atom (nullable) is None
    # and __fields_set__ contains the field
    if self.unit_amount_atom is None and 'unit_amount_atom' in self.__fields_set__:
      _dict['unit_amount_atom'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> CreateCreditNoteLine:
    """Create an instance of CreateCreditNoteLine from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return CreateCreditNoteLine.parse_obj(obj)

    _obj = CreateCreditNoteLine.parse_obj(
      {
        'amount_atom': obj.get('amount_atom'),
        'currency': obj.get('currency'),
        'type': obj.get('type'),
        'quantity': obj.get('quantity') if obj.get('quantity') is not None else 1,
        'invoice_item_id': obj.get('invoice_item_id'),
        'unit_amount_atom': obj.get('unit_amount_atom')
      }
    )
    return _obj
