# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import List, Optional

from getopenpay.models.create_credit_note_line import CreateCreditNoteLine
from getopenpay.models.credit_note_reason import CreditNoteReason
from getopenpay.models.currency_enum import CurrencyEnum
from pydantic import BaseModel, Field, StrictInt, StrictStr, conlist


class CreateCreditNoteRequest(BaseModel):
  """
    CreateCreditNoteRequest
    """
  invoice_id: StrictStr = Field(..., description='ID of the invoice')
  reason: Optional[CreditNoteReason] = None
  total_amount_atom: StrictInt = Field(
    ..., description='The int amount representing the total amount of the credit note.'
  )
  credit_amount_atom: Optional[StrictInt] = Field(
    0,
    description=
    'The integer amount representing the amount to credit the customer’s balance, which will be automatically applied to their next invoice.'
  )
  refund_amount_atom: Optional[StrictInt] = Field(
    0,
    description=
    'The integer amount representing the amount to refund. If set, a refund will be created for the charge associated with the invoice.'
  )
  lines: conlist(CreateCreditNoteLine) = Field(...)
  currency: Optional[CurrencyEnum] = None
  __properties = [
    'invoice_id', 'reason', 'total_amount_atom', 'credit_amount_atom', 'refund_amount_atom',
    'lines', 'currency'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> CreateCreditNoteRequest:
    """Create an instance of CreateCreditNoteRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # override the default output from pydantic by calling `to_dict()` of each item in lines (list)
    _items = []
    if self.lines:
      for _item in self.lines:
        if _item:
          _items.append(_item.to_dict())
      _dict['lines'] = _items
    # set to None if reason (nullable) is None
    # and __fields_set__ contains the field
    if self.reason is None and 'reason' in self.__fields_set__:
      _dict['reason'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> CreateCreditNoteRequest:
    """Create an instance of CreateCreditNoteRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return CreateCreditNoteRequest.parse_obj(obj)

    _obj = CreateCreditNoteRequest.parse_obj(
      {
        'invoice_id': obj.get('invoice_id'),
        'reason': obj.get('reason'),
        'total_amount_atom': obj.get('total_amount_atom'),
        'credit_amount_atom':
          obj.get('credit_amount_atom') if obj.get('credit_amount_atom') is not None else 0,
        'refund_amount_atom':
          obj.get('refund_amount_atom') if obj.get('refund_amount_atom') is not None else 0,
        'lines':
          [CreateCreditNoteLine.from_dict(_item) for _item in obj.get('lines')]
          if obj.get('lines') is not None else None,
        'currency': obj.get('currency')
      }
    )
    return _obj
