# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from getopenpay.models.currency_enum import CurrencyEnum
from pydantic import BaseModel, Field, StrictInt, StrictStr


class CreateCustomerBalanceTransactionRequest(BaseModel):
  """
    CreateCustomerBalanceTransactionRequest
    """
  amount_atom: StrictInt = Field(
    ...,
    description=
    'The amount of the transaction in atomic units (in USD this is cents). A negative value is a credit for the customer’s balance, and a positive value is a debit to the customer’s balance.'
  )
  currency: Optional[CurrencyEnum] = None
  description: Optional[StrictStr] = None
  __properties = ['amount_atom', 'currency', 'description']

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> CreateCustomerBalanceTransactionRequest:
    """Create an instance of CreateCustomerBalanceTransactionRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # set to None if description (nullable) is None
    # and __fields_set__ contains the field
    if self.description is None and 'description' in self.__fields_set__:
      _dict['description'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> CreateCustomerBalanceTransactionRequest:
    """Create an instance of CreateCustomerBalanceTransactionRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return CreateCustomerBalanceTransactionRequest.parse_obj(obj)

    _obj = CreateCustomerBalanceTransactionRequest.parse_obj(
      {
        'amount_atom': obj.get('amount_atom'),
        'currency': obj.get('currency'),
        'description': obj.get('description')
      }
    )
    return _obj
