# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import List, Optional

from pydantic import BaseModel, Field, StrictStr, conlist


class CreateProductFamilyRequest(BaseModel):
  """
    CreateProductFamilyRequest
    """
  name: StrictStr = Field(..., description='The name of the product family.')
  description: Optional[StrictStr] = None
  products: conlist(StrictStr) = Field(...)
  hierarchy: Optional[StrictStr] = Field(
    '{}', description='A JSON object representing the hierarchy within the family.'
  )
  __properties = ['name', 'description', 'products', 'hierarchy']

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> CreateProductFamilyRequest:
    """Create an instance of CreateProductFamilyRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # set to None if description (nullable) is None
    # and __fields_set__ contains the field
    if self.description is None and 'description' in self.__fields_set__:
      _dict['description'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> CreateProductFamilyRequest:
    """Create an instance of CreateProductFamilyRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return CreateProductFamilyRequest.parse_obj(obj)

    _obj = CreateProductFamilyRequest.parse_obj(
      {
        'name': obj.get('name'),
        'description': obj.get('description'),
        'products': obj.get('products'),
        'hierarchy': obj.get('hierarchy') if obj.get('hierarchy') is not None else '{}'
      }
    )
    return _obj
