# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Optional

from getopenpay.models.subscription_cancellation_details import SubscriptionCancellationDetails
from pydantic import BaseModel, Field, StrictBool


class DeleteSubscriptionRequest(BaseModel):
  """
    DeleteSubscriptionRequest
    """
  cancellation_details: Optional[SubscriptionCancellationDetails] = None
  cancel_unpaid_invoices: Optional[StrictBool] = Field(
    False, description='Mark unpaid invoices as uncollectible'
  )
  prorate: Optional[StrictBool] = Field(
    True,
    description=
    'Will generate a proration invoice_item that credits remaining unused time until the subscription period end, also creates invoice_item for un-invoiced metered usage.Setting this to false will not invoice for un-invoiced metered usage.'
  )
  full_refund: Optional[StrictBool] = Field(
    False, description='Flag to decide whether full refund should be given or not.'
  )
  is_preview: Optional[StrictBool] = Field(
    False,
    description="Whether the request is in preview mode (subscriptions won't actually be deleted)"
  )
  __properties = [
    'cancellation_details', 'cancel_unpaid_invoices', 'prorate', 'full_refund', 'is_preview'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> DeleteSubscriptionRequest:
    """Create an instance of DeleteSubscriptionRequest from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # override the default output from pydantic by calling `to_dict()` of cancellation_details
    if self.cancellation_details:
      _dict['cancellation_details'] = self.cancellation_details.to_dict()
    # set to None if cancellation_details (nullable) is None
    # and __fields_set__ contains the field
    if self.cancellation_details is None and 'cancellation_details' in self.__fields_set__:
      _dict['cancellation_details'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> DeleteSubscriptionRequest:
    """Create an instance of DeleteSubscriptionRequest from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return DeleteSubscriptionRequest.parse_obj(obj)

    _obj = DeleteSubscriptionRequest.parse_obj(
      {
        'cancellation_details':
          SubscriptionCancellationDetails.from_dict(obj.get('cancellation_details'))
          if obj.get('cancellation_details') is not None else None,
        'cancel_unpaid_invoices':
          obj.get('cancel_unpaid_invoices')
          if obj.get('cancel_unpaid_invoices') is not None else False,
        'prorate': obj.get('prorate') if obj.get('prorate') is not None else True,
        'full_refund': obj.get('full_refund') if obj.get('full_refund') is not None else False,
        'is_preview': obj.get('is_preview') if obj.get('is_preview') is not None else False
      }
    )
    return _obj
