# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, Dict, Optional

from getopenpay.models.object_name import ObjectName
from pydantic import BaseModel, Field, StrictBool, StrictStr


class DisputeExternal(BaseModel):
  """
    DisputeExternal
    """
  id: StrictStr = Field(..., description='Unique identifier of the dispute.')
  object: Optional[ObjectName] = None
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  is_deleted: Optional[StrictBool] = Field(
    False, description='If true, indicates that this object has been deleted'
  )
  their_dispute_id: StrictStr = Field(..., description='There dispute id.')
  account_id: StrictStr = Field(..., description='Unique identifier for the account.')
  payment_intent_id: StrictStr = Field(..., description='The payment intent id.')
  their_payment_intent_id: StrictStr = Field(..., description='Their payment intent id')
  reason: Optional[StrictStr] = None
  metadata: Optional[Dict[str, Any]] = None
  __properties = [
    'id', 'object', 'created_at', 'updated_at', 'is_deleted', 'their_dispute_id', 'account_id',
    'payment_intent_id', 'their_payment_intent_id', 'reason', 'metadata'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> DisputeExternal:
    """Create an instance of DisputeExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # set to None if reason (nullable) is None
    # and __fields_set__ contains the field
    if self.reason is None and 'reason' in self.__fields_set__:
      _dict['reason'] = None

    # set to None if metadata (nullable) is None
    # and __fields_set__ contains the field
    if self.metadata is None and 'metadata' in self.__fields_set__:
      _dict['metadata'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> DisputeExternal:
    """Create an instance of DisputeExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return DisputeExternal.parse_obj(obj)

    _obj = DisputeExternal.parse_obj(
      {
        'id': obj.get('id'),
        'object': obj.get('object'),
        'created_at': obj.get('created_at'),
        'updated_at': obj.get('updated_at'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'their_dispute_id': obj.get('their_dispute_id'),
        'account_id': obj.get('account_id'),
        'payment_intent_id': obj.get('payment_intent_id'),
        'their_payment_intent_id': obj.get('their_payment_intent_id'),
        'reason': obj.get('reason'),
        'metadata': obj.get('metadata')
      }
    )
    return _obj
