# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, Dict, Optional

from getopenpay.models.event_type import EventType
from getopenpay.models.object_name import ObjectName
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr


class EventExternal(BaseModel):
  """
    EventExternal
    """
  id: StrictStr = Field(...)
  object: Optional[ObjectName] = None
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  is_deleted: Optional[StrictBool] = Field(
    False, description='If true, indicates that this object has been deleted'
  )
  account_id: Optional[StrictStr] = Field(...)
  type: EventType = Field(...)
  data: Dict[str, Any] = Field(...)
  data_previous: Optional[Dict[str, Any]] = Field(...)
  request_id: Optional[StrictStr] = Field(...)
  request_idempotency_key: Optional[StrictStr] = Field(...)
  pending_webhooks: StrictInt = Field(...)
  user: Optional[StrictStr] = None
  __properties = [
    'id', 'object', 'created_at', 'updated_at', 'is_deleted', 'account_id', 'type', 'data',
    'data_previous', 'request_id', 'request_idempotency_key', 'pending_webhooks', 'user'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> EventExternal:
    """Create an instance of EventExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # set to None if account_id (nullable) is None
    # and __fields_set__ contains the field
    if self.account_id is None and 'account_id' in self.__fields_set__:
      _dict['account_id'] = None

    # set to None if data_previous (nullable) is None
    # and __fields_set__ contains the field
    if self.data_previous is None and 'data_previous' in self.__fields_set__:
      _dict['data_previous'] = None

    # set to None if request_id (nullable) is None
    # and __fields_set__ contains the field
    if self.request_id is None and 'request_id' in self.__fields_set__:
      _dict['request_id'] = None

    # set to None if request_idempotency_key (nullable) is None
    # and __fields_set__ contains the field
    if self.request_idempotency_key is None and 'request_idempotency_key' in self.__fields_set__:
      _dict['request_idempotency_key'] = None

    # set to None if user (nullable) is None
    # and __fields_set__ contains the field
    if self.user is None and 'user' in self.__fields_set__:
      _dict['user'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> EventExternal:
    """Create an instance of EventExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return EventExternal.parse_obj(obj)

    _obj = EventExternal.parse_obj(
      {
        'id': obj.get('id'),
        'object': obj.get('object'),
        'created_at': obj.get('created_at'),
        'updated_at': obj.get('updated_at'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'account_id': obj.get('account_id'),
        'type': obj.get('type'),
        'data': obj.get('data'),
        'data_previous': obj.get('data_previous'),
        'request_id': obj.get('request_id'),
        'request_idempotency_key': obj.get('request_idempotency_key'),
        'pending_webhooks': obj.get('pending_webhooks'),
        'user': obj.get('user')
      }
    )
    return _obj
