# coding: utf-8

"""
    OpenPay API

    super charge your subscription management.

    The version of the OpenAPI document: 1.2.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Any, Dict, List, Optional

from getopenpay.models.object_name import ObjectName
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist


class ProductExternal(BaseModel):
  """
    ProductExternal
    """
  id: StrictStr = Field(..., description='Unique identifier of the product.')
  object: Optional[ObjectName] = None
  created_at: datetime = Field(
    ..., description="DateTime at which the object was created, in 'ISO 8601' format."
  )
  updated_at: datetime = Field(
    ..., description="DateTime at which the object was updated, in 'ISO 8601' format."
  )
  is_deleted: Optional[StrictBool] = Field(
    False, description='If true, indicates that this object has been deleted'
  )
  name: StrictStr = Field(..., description='Name of product.')
  description: Optional[StrictStr] = Field(...)
  features: conlist(StrictStr) = Field(...)
  default_price: Optional[StrictStr] = Field(...)
  is_active: StrictBool = Field(
    ..., description='Whether the product is currently available for purchase.'
  )
  prices: conlist(PriceExternal) = Field(...)
  account_sku: Optional[StrictStr] = Field(...)
  unit_label: Optional[StrictStr] = Field(...)
  metadata: Optional[Dict[str, Any]] = None
  custom_fields: Optional[Dict[str, Any]] = None
  __properties = [
    'id', 'object', 'created_at', 'updated_at', 'is_deleted', 'name', 'description', 'features',
    'default_price', 'is_active', 'prices', 'account_sku', 'unit_label', 'metadata', 'custom_fields'
  ]

  class Config:
    """Pydantic configuration"""
    allow_population_by_field_name = True
    validate_assignment = True

  def to_str(self) -> str:
    """Returns the string representation of the model using alias"""
    return pprint.pformat(self.dict(by_alias=True))

  def to_json(self) -> str:
    """Returns the JSON representation of the model using alias"""
    return json.dumps(self.to_dict())

  @classmethod
  def from_json(cls, json_str: str) -> ProductExternal:
    """Create an instance of ProductExternal from a JSON string"""
    return cls.from_dict(json.loads(json_str))

  def to_dict(self):
    """Returns the dictionary representation of the model using alias"""
    _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
    # override the default output from pydantic by calling `to_dict()` of each item in prices (list)
    _items = []
    if self.prices:
      for _item in self.prices:
        if _item:
          _items.append(_item.to_dict())
      _dict['prices'] = _items
    # set to None if description (nullable) is None
    # and __fields_set__ contains the field
    if self.description is None and 'description' in self.__fields_set__:
      _dict['description'] = None

    # set to None if default_price (nullable) is None
    # and __fields_set__ contains the field
    if self.default_price is None and 'default_price' in self.__fields_set__:
      _dict['default_price'] = None

    # set to None if account_sku (nullable) is None
    # and __fields_set__ contains the field
    if self.account_sku is None and 'account_sku' in self.__fields_set__:
      _dict['account_sku'] = None

    # set to None if unit_label (nullable) is None
    # and __fields_set__ contains the field
    if self.unit_label is None and 'unit_label' in self.__fields_set__:
      _dict['unit_label'] = None

    # set to None if metadata (nullable) is None
    # and __fields_set__ contains the field
    if self.metadata is None and 'metadata' in self.__fields_set__:
      _dict['metadata'] = None

    # set to None if custom_fields (nullable) is None
    # and __fields_set__ contains the field
    if self.custom_fields is None and 'custom_fields' in self.__fields_set__:
      _dict['custom_fields'] = None

    return _dict

  @classmethod
  def from_dict(cls, obj: dict) -> ProductExternal:
    """Create an instance of ProductExternal from a dict"""
    if obj is None:
      return None

    if not isinstance(obj, dict):
      return ProductExternal.parse_obj(obj)

    _obj = ProductExternal.parse_obj(
      {
        'id': obj.get('id'),
        'object': obj.get('object'),
        'created_at': obj.get('created_at'),
        'updated_at': obj.get('updated_at'),
        'is_deleted': obj.get('is_deleted') if obj.get('is_deleted') is not None else False,
        'name': obj.get('name'),
        'description': obj.get('description'),
        'features': obj.get('features'),
        'default_price': obj.get('default_price'),
        'is_active': obj.get('is_active'),
        'prices':
          [PriceExternal.from_dict(_item) for _item in obj.get('prices')]
          if obj.get('prices') is not None else None,
        'account_sku': obj.get('account_sku'),
        'unit_label': obj.get('unit_label'),
        'metadata': obj.get('metadata'),
        'custom_fields': obj.get('custom_fields')
      }
    )
    return _obj


from getopenpay.models.price_external import PriceExternal

ProductExternal.update_forward_refs()
